// UO Dogsbody  Shaun A Stevens 2001
// 

// ------- globals --------

var wsh = new ActiveXObject("WScript.Shell");
var fso = new ActiveXObject("Scripting.FileSystemObject");

var menulinkstr = new Array(7);      // <---------------- onscreen menus, .div's in HTA appended with edit for 
for (i = 0; i < menulinkstr.length; i++) { //------------ popup, td for menu holder and mu for value display
 menulinkstr[i] = new Object();
}
menulinkstr[0].type = "exclude";
menulinkstr[0].div = "item";
menulinkstr[0].cat = "name";
menulinkstr[1].type = "exclude";
menulinkstr[1].div = "dur";
menulinkstr[1].cat = "durability";
menulinkstr[2].type = "exclude";
menulinkstr[2].div = "acc";
menulinkstr[2].cat = "accuracy";
menulinkstr[3].type = "exclude";
menulinkstr[3].div = "dmg";
menulinkstr[3].cat = "damage";
menulinkstr[4].type = "exclude";
menulinkstr[4].div = "arm";
menulinkstr[4].cat = "armour";
menulinkstr[5].type = "toggle";
menulinkstr[5].div = "slv";
menulinkstr[5].cat = "silver";
menulinkstr[6].type = "toggle";
menulinkstr[6].div = "ext";
menulinkstr[6].cat = "extrainfo";


menucats = new ActiveXObject("Scripting.Dictionary"); // <------------- menus enabled by stock cat's
menucats.Add("weapons", "item,dur,acc,dmg,slv,ext");
menucats.Add("armour", "item,dur,arm,ext");
menucats.Add("none", "item");

weaponinfo = new ActiveXObject("Scripting.Dictionary"); // --------------- numerical bonus values, weapons
weaponinfo.Add("durable",10);
weaponinfo.Add("substantial",20);
weaponinfo.Add("massive",30);
weaponinfo.Add("fortified",40);
weaponinfo.Add("indestructable",50);
weaponinfo.Add("ruin",1);
weaponinfo.Add("might",3);
weaponinfo.Add("force",5);
weaponinfo.Add("power",7);
weaponinfo.Add("vanquishing",9);
weaponinfo.Add("accurate","5,4.6");
weaponinfo.Add("surpassingly","10,9.3");
weaponinfo.Add("eminently","15,14");
weaponinfo.Add("exceedingly","20,18.7");
weaponinfo.Add("supremely","25,23.3");
weaponinfo.Add("info1",0);
weaponinfo.Add("info2",1);
weaponinfo.Add("infotypes","tacts,arch");

armourinfo = new ActiveXObject("Scripting.Dictionary"); // --------------- numerical bonus values, armour
armourinfo.Add("defence","0.4,0.7,2.2,2.9");
armourinfo.Add("guarding","0.7,1.4,4.4,5.8");
armourinfo.Add("hardening","1.1,2.1,6.6,8.7");
armourinfo.Add("fortification","1.4,2.8,8.8,11.6");
armourinfo.Add("invulnerability","1.8,3.5,11.0,14.5");
armourinfo.Add("durable",5);
armourinfo.Add("substantial",10);
armourinfo.Add("massive",15);
armourinfo.Add("fortified",20);
armourinfo.Add("indestructable",25);
armourinfo.Add("info1",0);
armourinfo.Add("info2",1);
armourinfo.Add("info3",2);
armourinfo.Add("info4",3);


abridged = new ActiveXObject("Scripting.Dictionary"); // <------------------- shortened descriptions
abridged.Add("invulnerability","invul");
abridged.Add("indestructable","indst");
abridged.Add("fortification","fort");
abridged.Add("surpassingly","srpas");
abridged.Add("exceedingly","exced");
abridged.Add("vanquishing","vanq");
abridged.Add("substantial","subst");
abridged.Add("hardening","hrdng");
abridged.Add("fortified","fortf");
abridged.Add("eminently","ement");
abridged.Add("supremely","suprm");
abridged.Add("guarding","grdng");
abridged.Add("accurate","accrt");
abridged.Add("durable","durbl");
abridged.Add("defence","defnc");
abridged.Add("massive","massv");


// NOTE ---- also need to add entries in database pricechecker when adding new menus !


// --------- OBJECTS -------------

// Item Object 

function itemObject(dbaseobj) {
 this.vendorobj = dbaseobj;
 this.name = "none";
 this.infocat = "";
 this.silver = false;
 this.extrainfo = false;
 this.accuracy = "none";
 this.durability = "none";
 this.armour = "none";
 this.damage = "none";
 this.price = 0;
 this.markup = 0;
 this.description = "Welcome Master, how may I help you?";
 this.getprice = refreshprice;
 this.markups = new Object();
}

//------------- get prices and output string for current item using dbase values

function refreshprice() {
 var i = 0;
 var price;
 var markup = new Number(0);
 var tmp;
 var acc = "";
 var dur = "";
 var dmg = "";
 var slv = "";
 var arm = "";
 var infos = "";
 var infostr = new Array(5);

 price = parseInt(this.vendorobj.itemvalue(this.name, "baseprice"));

 if (this.silver && this.vendorobj.itemvalue(this.name, "silver")) {
  tmp = (this.vendorobj.itemvalue(this.name,'silver') == "y") ? "default":this.name;
  this.markups.silver = parseFloat(this.vendorobj.itemvalue(tmp, "silver"));
  markup += this.markups.silver; 
  slv = "silver";
  if (this.extrainfo) {
   infostr[3] = "*2v.undead";
  }
 
 }
 if (this.vendorobj.itemvalue(this.name, "damage")) {
  tmp = (!this.vendorobj.itemvalue(this.name, this.damage)) ? "default":this.name;
  this.markups.damage = parseFloat(this.vendorobj.itemvalue(tmp, this.damage)); 
  markup += this.markups.damage;
  dmg += " of " + this.damage; 
  if (this.extrainfo && this.damage != "none") {
   infostr[2] = "+" + weaponinfo.Item(this.damage) + "dmg";
  }
 }
 if (this.vendorobj.itemvalue(this.name, "accuracy")) {
  tmp = (!this.vendorobj.itemvalue(this.name, this.accuracy)) ? "default":this.name;
  this.markups.accuracy = parseFloat(this.vendorobj.itemvalue(tmp, this.accuracy)); 
  markup += this.markups.accuracy; 
  acc = this.accuracy;
  if (this.accuracy != "accurate" && this.accuracy != "none") acc += " accurate";
  if (this.silver) acc += ", ";
  if (this.extrainfo && this.accuracy != "none") {
   infostr[1] = "+" + (weaponinfo.Item(this.accuracy).split(","))[weaponinfo.Item(this.infocat)] + (weaponinfo.Item("infotypes").split(","))[weaponinfo.Item(this.infocat)];
  }
 }
 if (this.vendorobj.itemvalue(this.name, "armour")) {
  tmp = (!this.vendorobj.itemvalue(this.name, this.armour)) ? "default":this.name;
  this.markups.armour = parseFloat(this.vendorobj.itemvalue(tmp, this.armour)); 
  markup += this.markups.armour; 
  arm += " of " + this.armour; 
  if (this.extrainfo && this.armour != "none" && this.infocat != "off") {
   infostr[2] = "+" + (armourinfo.Item(this.armour).split(","))[armourinfo.Item(this.infocat)] + "avg ac";
  }
 }
 if (this.vendorobj.itemvalue(this.name, "durability")) {
  tmp = (!this.vendorobj.itemvalue(this.name, this.durability)) ? "default":this.name;
  this.markups.durability = parseFloat(this.vendorobj.itemvalue(tmp, this.durability)); 
  markup += this.markups.durability;
  dur = this.durability;
  if ((this.accuracy != "none" || this.silver) && arm == "") dur += ", ";
  if (this.extrainfo && this.durability != "none") {
   if (this.vendorobj.itemvalue(this.name, "armour")) infostr[0] = "+" + armourinfo.Item(this.durability) + " item hps";
   else infostr[0] = "+" + weaponinfo.Item(this.durability) + "itmhps";
  }
 }
 this.price = Math.floor(price * ((markup/100) + 1)); 
  outputdiv.innerHTML = "<font color='darkred'>|</font> Item: <font color='darkblue'> " + this.name + " </font><font color='darkred'>|</font> base price: <font color='darkblue'>" + ((price) ? price:"Select a stock item") + " </font><font color='darkred'>|</font> markup: <font color='darkblue'>" + markup + "% </font><font color='darkred'>|</font> final: <font color='darkblue'>" + ((price) ? (price * ((markup/100) + 1)):"0") + "</font><font color='darkred'> |</font>";
 markup = (price * ((markup/100) + 1));

 if (price) this.description = Math.floor(markup) + " " + ((dur == "none" || dur == "none, ") ? "":dur) + ((acc == "none" || acc == "none, ") ? "":acc) + slv + ((dmg == " of none") ? "":dmg) + ((arm == " of none") ? "":arm);
 this.infos = "";
 for (i = 0; i < infostr.length; i++) {
  if (infostr[i]) this.infos += ((this.infos != "") ? ", ":"") + infostr[i] ;
 }
}



// MENUS/SCREEN OBJECT

function screenobject(itemobj) {
 this.itemobject = itemobj;
 this.menus = new ActiveXObject("Scripting.Dictionary");
 this.lastcat = "";
 this.update = updatescreen;
 var i = 0;
 for (i = 0; i < menulinkstr.length; i ++) {
  menuobject = new menusobj(menulinkstr[i].type ,menulinkstr[i].div);
  this.menus.Add(menulinkstr[i].cat,menuobject);
 }
} 

function menusobj(menutype,menudiv) {
 this.type = menutype;
 this.menuholder = menudiv;
 this.lasteventgraphic = ""; 
 this.enabled = true;
 this.editenabled = false;
}


//------------------ update the display area, depends on item object

function updatescreen(cat,discat,radioname) {
 var i,a;
 var obj;
 var tmp;
 var tmpstr;
 var re = new RegExp();
 if (this.menus.Item(cat).enabled) {
  
  a = new VBArray(this.menus.Keys()).toArray();
  for (i in a) {
   if (discat) { 
    if (menucats.Item(discat).indexOf(this.menus.Item(a[i]).menuholder) != -1) {
     eval(this.menus.Item(a[i]).menuholder + "td.style.filter = ''");
     this.menus.Item(a[i]).enabled = true;
    }
    else {
     eval(this.menus.Item(a[i]).menuholder + "td.style.filter = 'Alpha(Opacity=25)'"); 
     this.menus.Item(a[i]).enabled = false;
    }
   } 
   if (eval("document.all." + this.menus.Item(a[i]).menuholder + "edit")) {
    if (this.itemobject[a[i]] == "none" || this.itemobject[a[i]] == false) {
     if (this.menus.Item(a[i]).enabled) eval(this.menus.Item(a[i]).menuholder + "edit.style.filter = 'Alpha(Opacity=25)'");
     else eval(this.menus.Item(a[i]).menuholder + "edit.style.filter = ''");
     eval(this.menus.Item(a[i]).menuholder + "edit.className = 'disableddopt'");
     eval(this.menus.Item(a[i]).menuholder + "mu.innerHTML = 0");
     this.menus.Item(a[i]).editenabled = false;
    }
    else {
     eval(this.menus.Item(a[i]).menuholder + "edit.style.filter = ''");
     if (this.menus.Item(a[i]).enabled) {
      eval(this.menus.Item(a[i]).menuholder + "mu.innerHTML = this.itemobject.markups." + a[i]);
      this.menus.Item(a[i]).editenabled = true;
      eval(this.menus.Item(a[i]).menuholder + "edit.className = 'enabledopt'");
     }
     else { 
      eval(this.menus.Item(a[i]).menuholder + "mu.innerHTML = 0");
      this.menus.Item(a[i]).editenabled = false;
      eval(this.menus.Item(a[i]).menuholder + "edit.className = 'disabledopt'");
     }
    }
   }
  }
  if (radioname) {
   obj = this.menus.Item(cat);
   if (obj.type == "exclude") {
    if (obj.lasteventgraphic) obj.lasteventgraphic.className = "selectoff";
    document.all[radioname].className = 'selecton';
    obj.lasteventgraphic = document.all[radioname];
   }
   if (obj.type == "toggle") {
    if (obj.lasteventgraphic) {
     document.all[radioname].className = 'selectoff';
     obj.lasteventgraphic = false;
    }
    else {
     document.all[radioname].className = 'selecton';
     obj.lasteventgraphic = true;
    }
   } 
  }
  
  
  tmpstr = this.itemobject.description + ((this.itemobject.extrainfo && this.itemobject.infos) ? (" (" + this.itemobject.infos + ")"):"");
  if (this.itemobject.extrainfo) {
   a = new VBArray(abridged.Keys()).toArray();
   i = 0;
   while (i < a.length && tmpstr.length > 80) {
    re.compile(a[i],"g");
    tmpstr = tmpstr.replace(re,abridged.Item(a[i]));
    i++;
   }
  }
  outform.outputtext.value = tmpstr; 
 }
}



// -------- database object definition --------------

function dbase(dbasefile) { 
 fs = fso.OpenTextFile(dbasefile);
 this.dbr = new Array();
 this.dicols = new ActiveXObject("Scripting.Dictionary");
 this.dirows = new ActiveXObject("Scripting.Dictionary");
 this.itemvalue = getvalue;
 this.setitemvalue = setvalue;
 this.update = updatewholedbase;
 this.filename = dbasefile;
 var i = 0;
 while (!fs.AtEndOfStream) {
  tmpstr = fs.ReadLine();
  this.dbr[i] = tmpstr.split('#');
  i++;
 }
 fs.Close();
 for (i = 0; i < this.dbr[0].length; i++) {
  this.dicols.Add(this.dbr[0][i],i);
 }
 for (i = 1; i < this.dbr.length; i++) {
  this.dirows.Add(this.dbr[i][0],i);
 }
} 
 

function updatewholedbase() {
 var i;
 fsout = fso.CreateTextFile(stockdbase.filename + ".backup",true);
 for (i = 0; i < this.dbr.length; i++) {
  fsout.WriteLine(this.dbr[i].join("#"));
 }
 fsout.close();
 fso.CopyFile(stockdbase.filename + ".backup",stockdbase.filename,true)
}

function setvalue(rowkey,colkey,newvalue) {
 this.dbr[this.dirows.Item(rowkey)][this.dicols.Item(colkey)] = newvalue;
}

function getvalue(rowkey,colkey) {
 if (rowkey && colkey) return(this.dbr[this.dirows.Item(rowkey)][this.dicols.Item(colkey)]);
} 
 
// ------------------ END database object definition -----------------------


// ------------------ Key strokes object ---------------------------



function keyStrokes(app) {
 this.keystr = "";
 this.app = app;
 this.transmit = sendKey;
}


function sendKey() {
 if(wsh.AppActivate(this.app)) {
  wsh.sendKeys("% R");
  if (this.tid) clearTimeout(this.tid);
  this.tid = setTimeout("finalsend('" + this.keystr + "')",600);
 }
}

function finalsend(keystr) {
 keystr = keystr.replace((/\+/g),"{+}");
 keystr = keystr.replace((/\%/g),"{%}");
 keystr = keystr.replace((/\(/g),"{(}");
 keystr = keystr.replace((/\)/g),"{)}");
 wsh.SendKeys(keystr);
}






// ------- END OBJECTS -----------------


// ------- Page EVENTS ----------------------


//--------------- called on STARTUP

function initapp() {
 stockdbase = new dbase("database.txt");
 UOdata = new keyStrokes("ultima online");
 vendor = new itemObject(stockdbase);
 display = new screenobject(vendor);
 popupheader.onmousedown = dragobjon;
 popupheader.onmouseup = dragobjoff;
 document.onmousemove = dragobjcheck;
 body.onmousedown = clearpopup;
 window.onerror = traperrors;
 window.onresize = positionver;
 tmp = navigator.appVersion;
 clientversion = parseFloat(tmp.substring(tmp.indexOf("MSIE",0) + 5, tmp.indexOf(";",tmp.indexOf("MSIE",0))));
 if (clientversion < 5.5) allowedit = false;
 else allowedit = true;
 if (ScriptEngineMajorVersion() == 5) {
  if (ScriptEngineMinorVersion() < 1) traperrors();
 }
 else traperrors();
 vendor.getprice();
 display.update("name","none");
 setversion();
}


//---------------- version status

function setversion() {
var v = UODB.version;
ver.innerHTML = "<nobr>UO Dogsbody  S.A.Stevens 2001 v " + v + "</nobr>"; 
positionver()
}

//--------------- position uodb info & version

function positionver() {
ver.style.top = (maintable.offsetHeight - (ver.offsetHeight - 10));
ver.style.left = (maintable.offsetWidth - (ver.offsetWidth - 10));
return(true);
}


//---------------- error handler (unfinished)

function traperrors() {
window.alert("Error: This application needs at least version 5.1 of windows scripting host to work correctly\n www.microsoft.com/msdownload/vbscript/scripting.asp");
window.close();
return(false);
}

//---------------- called when price tag button pushed


function senddata() {
 UOdata.keystr = outform.outputtext.value + "~";
 UOdata.transmit();
 return(true);
}

//----------------- called when list headers clicked (opens and closes list's divs)


function openlist(listblock) {
 var obj = eval("document.all." + listblock);
 if (!obj.activated) {
  obj.style.display = "block";
  obj.activated = 1;
 }
 else {
  obj.style.display = "none";
  obj.activated = 0;
 }
}

//------------------- tick box's event handler


function select(radioname,typecat,discat,infocat) {
 if (display.menus.Item(typecat).enabled) {
 if (display.menus.Item(typecat).type == "toggle") {
  if (display.menus.Item(typecat).lasteventgraphic) {
   eval("vendor." + typecat + "= false");
  }
  else {
   eval("vendor." + typecat + "= true"); 
  }
 }
 else {
  if (radioname.indexOf("none") == -1) {
   eval("vendor." + typecat + "= radioname");
  }
  else {
   eval("vendor." + typecat + "= 'none'");
  }
 }
 if (typecat == "name") {
  if (infocat) vendor.infocat = infocat;
  else vendor.infocat = "info1";
 }
 vendor.getprice();
 display.update(typecat,discat,radioname);
 }
}



// ---------------- POPUP FORM STUFF


// ----------------- brings up edit popup, called by clicking editables

function changemarkup(formstr,formtype,fld1,fld2,fld3,fld4,fld5) {
 var tmp,tmp2;
 formstr = formstr.toLowerCase();
 tmp2 = document.all[formstr];
 clearpopup();
 if (formtype == "stockprc" || (display.menus.Item(formstr).enabled && display.menus.Item(formstr).editenabled)) {
 popup.shown = true;
 popup.popupform = eval(formtype + "form");
 eval(formtype + "form.className = 'inputformon'");
 if (fld1) {
  popupheader.innerHTML = "edit <span class='morebold'> " + formstr + "</span> bonus"; 
  infodiv.innerHTML = "item:<b> " + vendor.name + "</b><br>";
  eval(formtype + "form." + fld1 + ".value = stockdbase.itemvalue('default',vendor." + formstr + ")"); 
  tmp = eval(formtype + "form." + fld1 + "button");
  tmp.itemname = "default";
  tmp.itemcol = eval("vendor." + formstr); 
  tmp.itemvalue = eval(formtype + "form." + fld1);
 }
 if (fld2) {
  infodiv.innerHTML += "bonus:<b> " + eval("vendor." + formstr) + "</b>";
  eval(formtype + "form." + fld2 + ".value = stockdbase.itemvalue(vendor.name,vendor." + formstr + ")"); 
  tmp = eval(formtype + "form." + fld2 + "button");
  tmp.itemname = vendor.name;
  tmp.itemcol = eval("vendor." + formstr); 
  tmp.itemvalue = eval(formtype + "form." + fld2);
 }
 if (fld3) {
  popupheader.innerHTML = "edit <span class='morebold'> base price</span>"; 
  infodiv.innerHTML = "item:<b> " + formstr + "</b>";
  eval(formtype + "form." + fld3 + ".value = stockdbase.itemvalue('" + formstr + "','baseprice')"); 
  tmp = eval(formtype + "form." + fld3 + "button");
  tmp.itemname = formstr;
  tmp.itemcol = 'baseprice'; 
  tmp.itemvalue = eval(formtype + "form." + fld3);
 }
 if (fld4) {
  popupheader.innerHTML = "edit <span class='morebold'> " + formstr + "</span> bonus"; 
  infodiv.innerHTML = "item:<b> " + vendor.name + "</b><br>";
  eval(formtype + "form." + fld4 + ".value = stockdbase.itemvalue('default',formstr)"); 
  tmp = eval(formtype + "form." + fld4 + "button");
  tmp.itemname = "default";
  tmp.itemcol = formstr; 
  tmp.itemvalue = eval(formtype + "form." + fld4);
 }
 if (fld5) {
  infodiv.innerHTML += "bonus:<b> " + formstr + "</b>";
  if (stockdbase.itemvalue(vendor.name,formstr) != "y") {
   eval(formtype + "form." + fld5 + ".value = stockdbase.itemvalue(vendor.name,formstr)"); 
  }
  else eval(formtype + "form." + fld5 + ".value = ''");
  tmp = eval(formtype + "form." + fld5 + "button");
  tmp.itemname = vendor.name;
  tmp.itemcol = formstr; 
  tmp.itemvalue = eval(formtype + "form." + fld5);
 }

 
 popupon();
 var tmpx = 0;
 tmpx = (popup.offsetWidth - (body.offsetWidth - event.clientX)) + 5;
 popup.offsetx = ((tmpx > 0) ? tmpx:0);
 popup.offsety = 0;
 positionpopup();
 popup.style.visibility = "visible";
 popupalpha.style.visibility = "visible";
 
 }
}

//--------- position popup's shadow <- positionpopup()

function popupshadow() {
 popupalpha.style.left = popup.style.pixelLeft + 5; 
 popupalpha.style.top = popup.style.pixelTop + 6; 
}

// -------- position popup while dragging <- dragobjcheck()
 
function positionpopup() {
 popup.style.pixelLeft = body.scrollLeft + event.clientX - popup.offsetx;
 popup.style.pixelTop = body.scrollTop + event.clientY - popup.offsety;
 popupshadow();
}

//---------- stop text being selectable, (unused)
function stopselect() {
return(false);
}

// --------- position popup editbox on first call <- changemarkup() dragobjon()

function popupon() {
popup.offsetx = (event.clientX - popup.offsetLeft);
popup.offsety = event.clientY - popup.offsetTop;
popupalpha.style.width = popup.offsetWidth; 
popupalpha.style.height = popup.offsetHeight;  
}

// ---------- onmousedown event of popupheader div

function dragobjon() {
popupon();
event.srcElement.drag = true;
document.lastdragobj = event.srcElement;
}

// ---------- onmouseup event of popupheader div

function dragobjoff() {
event.srcElement.drag = false;
}

// --------- global onmousemove event function used to drag popup

function dragobjcheck() {
 if (document.lastdragobj && document.lastdragobj.drag) {
  positionpopup();
 }
 return(allowedit);
}

// --------- global onmousedown event used to clear popup editbox from screen

function clearpopup() {
 if (popup.shown && ((event.clientX < popup.offsetLeft) || (event.clientX > popup.offsetLeft + popup.offsetWidth) || (event.clientY < popup.offsetTop) || (event.clientY > popup.offsetTop + popup.offsetHeight))) {
  popup.style.visibility = "hidden";
  popupalpha.style.visibility = "hidden";
  popup.popupform.className = "inputformsoff";
  popup.shown = false;
 }
}


// --------- popup form buttons handler

function changevalue(sitem,col,amount) {
 if (!isNaN(amount) && amount) {
  stockdbase.setitemvalue(sitem,col,amount);
  if (sitem == "default") {
   if (display.menus.Exists(col) && display.menus.Item(col).type == "toggle") {
    amount = "y";
   }
   else amount = "";
   stockdbase.setitemvalue(vendor.name,col,amount);
  }
  stockdbase.update();
  vendor.getprice();
  display.update("name");
 }
}

